using mailinator_csharp_client.Models.Responses;

namespace TestProject1
{
    [TestClass]
    public class MailinatorDemo
    {
        /// <summary>
        /// A basic test to show accessing an email via Mailinator.
        /// </summary>
        /// <returns></returns>
        [TestMethod]
        public async Task MailinatorTest()
        {
            // Create a config based on the specified file.
            MailinatorConfig creds = new(@"C:\files\MailinatorConfig\MailinatorConfig.txt");

            // Create a new, sufficiently unique email address
            EmailAddressManager emailManager = new(creds.DomainName);
            string emailId = emailManager.CreateNewEmailId();
            string emailAddress = emailManager.CreateEmailAddress(emailId);

            // Create a new account in the app under test
            AccountCreationPageObject accountCreationpage = new ();
            accountCreationpage.CreateNewAccount(creds, emailAddress);

            // Fetch the appropriate inbox
            MailinatorProxy mailinatorProxy = new (creds);
            FetchInboxResponse fetchInboxResponse = await mailinatorProxy.GetInbox(emailId, creds.DomainName);

            // Fetch the specific message
            FetchMessageResponse fetchMessageResponse = await mailinatorProxy.GetMessage(fetchInboxResponse, emailId, creds.DomainName);

            // Make sure we got the expected message
            Assert.AreEqual("Activation Email", fetchMessageResponse.Subject);
            
        }
    }
}